/*ghassan fakher
 * section 6
 gkf01*/
public class InsertionSortOfIntegers {
	public static void main(String[] args)
	{
		In input = new In("ints.txt");
		int[] inputInts = new int[input.readInt()];
		for(int i = 0; i < inputInts.length; i++)
			inputInts[i] = input.readInt();
		
		printArray(insertionSort2(inputInts));
		System.out.println();
		printArray(inputInts); // to check that the original array hasn't changed
		System.out.println();
		insertionSort(inputInts);
	}
	//method used to manipulate the array in order to sort it
	public static void insertionSort(int[] a){
		for (int i = 1; i < a.length; i++){
			int j = i;
			int numAti = a[i];
			while ((j > 0) && (a[j-1] > numAti)){ // putting in a place where it is larger than all its left neighbors.
				a[j] = a[j-1]; 
				j--;
			}
			a[j] = numAti;
		}
	}
	//method that makes a new array with the same elements as the original one
	public static int[] insertionSort2(int[] a){
		int[] clone = new int[a.length];
		for(int i = 0; i < clone.length; i++) // cloning the array.
			clone[i] =  a[i];
		
		insertionSort(clone);
		return clone;
	}
	public static void printArray(int[] a){
		for(int i = 0; i < a.length; i++)
			System.out.print(a[i] + " ");
	}
}
